﻿; ───────────────────────────────────────────────────────────────────────────
; Драйвер расширенной арифметики
; ───────────────────────────────────────────────────────────────────────────

; ====== cut on =============================================================
; Это свой стек, т.к. эмулятор тратит слишком много стека,
; и сдаточные тесты 791402 и 791403 ломаются.
; для обычного использования не нужно.
; Нужно удалить код, расположенный между строками == cut on == ... == cut off ==

EXTAEP:         mov     SP,ASP          ;сохраняем стек
                mov     R5,ATMP
                mov     SP,R5
                mov     #40000,SP       ;устанавливаем свой стек
                mov     2(R5),-(SP)     ;переносим туда PS
                mov     (R5),-(SP)      ;переносим туда PC
                mov     R5,-(SP)        ;сохраняем туда стек
                add     #4,(SP)         ;корректируем значение, чтоб как до прерывания было
                mov     ATMP,R5
                br      next1$

;возврат стека при выходе из п/п
;вызов: call retext
RETEXT:         mov     (SP)+,ARET      ;достаём адрес возврата
                mov     R5,ATMP
                mov     SP,R5
                mov     ASP,SP          ;восстанавливаем стек
                mov     2(R5),2(SP)     ;заменяем PS
                mov     (R5),(SP)       ;заменяем PC
                mov     ATMP,R5
                jmp     @ARET           ;возврат из п/п
; ───────────────────────────────────────────────────────────────────────────
ASP:            .word   0
ATMP:           .word   0
ARET:           .word   0
; ещё нужен свой перехватчик вектора 4
V4ADR:          .word   0
V4PSW:          .word   0
V4SP:           .word   0
; ───────────────────────────────────────────────────────────────────────────
emV4:           mov     V4SP, SP        ; восстанавливаем стек
                call    RESTR           ; восстановим регистры
                call    RETEXT
                mov     @#6, -(SP)      ; в стек PS вектора 4
                mov     @#4, -(SP)      ; в стек адрес вектора 4
                rti                     ; и переходим.
; ====== cut off ============================================================

;точка входа в драйвер расширенной арифметики.
;вход - прерывание по вектору 10
EXT:            mov     #6, -(SP)
                add     SP, (SP)        ; тут получается значение стека до возникновения прерывания
                                        ; это нужно, если для передачи параметров fis использовался SP
next1$:         mov     R5, -(SP)
                mov     R4, -(SP)
; ====== cut on =============================================================
                mov     #4, R4
                mov     (R4)+, V4ADR    ; сохраняем старый вектор 4
                mov     (R4), V4PSW     ; и его PSW
                mov     #340, (R4)      ; задаём свои параметры
                .addr   R5, emV4
                mov     R5, -(R4)
; ====== cut off ============================================================
                mov     6(SP), R5       ; берём адрес возврата из прерывания
                mov     -(R5), R4       ; получаем опкод, вызвавший прерывание
                mov     R3, -(SP)
                mov     R2, -(SP)
                mov     R1, -(SP)
                mov     R0, -(SP)
                mov     SP, V4SP
                mov     R4, R0          ; опкод
                mov     R0, R1          ; ещё раз
                cmp     R0, #75000      ; это fis ?
                bhis    FLTSET          ; скорее всего да, пойдём проверим
                jmp     EISSET          ; нет, может eis? пойдём проверим
; ───────────────────────────────────────────────────────────────────────────

ILCOD$:         call    RESTR           ; восстановим регистры
; ====== cut on =============================================================
                call    RETEXT
; ====== cut off ============================================================
; эмуляция прерывания по вектору 4
                mov     @#6, -(SP)      ; в стек PS вектора 4
                bis     #1, (SP)        ; установим там бит С
                mov     @#4, -(SP)      ; в стек адрес вектора 4
                RTI                     ; и переходим.
                ; в стеке остались PS/PC выхода из вектора 10.
                ; они будут использоваться при выходе из вектора 4
                ; или, если там стек напрямую инициализируется, то они не нужны
; ───────────────────────────────────────────────────────────────────────────

;п/п установки признаков и восстановления регистров
RSTRS:          bic     #17+140, 22(SP) ; чистим поле признаков в PS возврата из прерывания
                                        ; ещё надо очищать биты 6 и 5 для теста прохождения 791403
                bis     R5, 22(SP)      ; и устанавливаем там свои

;п/п восстановления регистров
RESTR:
; ====== cut on =============================================================
                mov     V4PSW,@#6       ;восстанавливаем перехваченный вектор 4
                mov     V4ADR,@#4
; ====== cut off ============================================================
                mov     (SP)+, 14(SP)   ; берём адрес возврата из RESTR или RSTRS, и сохраняем его
                                        ; на месте значения 6+SP
                mov     (SP)+, R0       ; восстанавливаем все регистры
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                mov     (SP)+, R4
                mov     (SP)+, R5
                return                  ; и выходим из п/п. Теперь в стеке только PC PS
                                        ; для выхода из прерывания

; ───────────────────────────────────────────────────────────────────────────
;умножение R0:R1 = R3:R4 * R5
IMUL:           clr     R1              ; тут накапливается результат
                clr     R0
                ror     R5              ; B.hi >> 1
                br      1$

3$:             add     R4, R1          ; R0:R1 += R3:R4
                adc     R0
                add     R3, R0
4$:             asl     R4              ; R3:R4 <<= 1
                rol     R3
2$:             asr     R5
1$:             bcs     3$              ; если 1, то пойдём делать сложение
                bne     4$              ; если 0, но ещё есть биты, то пойдём просто сдвигать
                return                  ; если всё - то выход.

; ───────────────────────────────────────────────────────────────────────────
FLTSET:         cmp     R0, #75040      ; точно fis ?
                blo     1$              ; да
                jmp     ILCOD$          ; нет - другие не эмулируемые опкоды

1$:             bic     #177747, R0     ; определим тип команды
                asr     R0
                asr     R0              ; тип команды * 2
                bic     #177770, R1     ; определим номер используемого регистра
                asl     R1              ; регистр * 2
                add     SP, R1          ; это адрес в стеке, где сохранено значение регистра
                mov     R1, -(SP)       ; и сохраним его в стеке. Оно нужно в конце, чтобы определить номер регистра
                mov     (R1), R1        ; достанем значение регистра
                mov     (R1)+, R2       ; B.hi
                mov     (R1)+, R3       ; B.lo
                mov     (R1)+, R4       ; A.hi
                mov     (R1)+, R5       ; A.lo
                mov     R1, -(SP)       ; и снова сохраним, потом туда результаты возвращать будем
                add     PC, R0
                add     #FPUTBL-., R0
                add     (R0), PC        ; и пойдём обрабатывать конкретную операцию
FPUTBL:         .word   FADD$-FPUTBL    ; 75000
                .word   FSUB$-FPUTBL    ; 75010
                .word   FMUL$-FPUTBL    ; 75020
                .word   FDIV$-FPUTBL    ; 75030
; ───────────────────────────────────────────────────────────────────────────
;деление A = A / B
FDIV$:          clr     -(SP)           ; флаг знака результата
                tst     R2              ; число B какое?
                bpl     1$              ; больше 0
                inc     (SP)            ; если меньше нуля, то результат будет отрицательный
1$:             tst     R4              ; число A какое?
                bpl     2$              ; больше 0
                inc     (SP)            ; если меньше нуля, то результат будет отрицательный,
                                        ; или, если B тоже было < 0, то положительный
2$:             call    MANEXP          ; разделяем мантиссу и порядок
                tst     R0              ; если порядок B.exp == 0
                bne     4$
                jmp     DIVZER          ; если равно 0 - ошибка, на 0 делить нельзя

4$:             tst     R1              ; если порядок A.exp == 0
                beq     FLZERO          ; то результат деления == 0
                sub     R0, R1          ; res.exp = A.exp - B.exp
                add     #177, R1        ; Прибавить 127
                mov     R1, -(SP)       ; сохраняем
                mov     #100, R1        ; начальное значение, бит, по которому будет выход из цикла
                clr     R0
                br      5$              ; и идём просто делить R4:R5 на R2:R3
; ───────────────────────────────────────────────────────────────────────────
; Деление без восстановления
6$:             asl     R5
                rol     R4
5$:             sub     R3, R5
                sbc     R4
                sub     R2, R4
                bmi     7$
8$:             sec                     ; очередной разряд
                rol     R1              ; частного = 1
                rol     R0
                bcc     6$
                br      9$

10$:            asl     R5
                rol     R4
                add     R3, R5
                adc     R4
                add     R2, R4
                bpl     8$
7$:             clc                     ; очередной разряд
                rol     R1              ; частного = 0
                rol     R0
                bcc     10$             ; повторить цикл

9$:             mov     R0, R2          ; вот результат
                mov     R1, R3          ; тут R1 == R3
                jmp     NORMRT          ; и по идее, R1 не нужен, при сдвиге вправо
; ───────────────────────────────────────────────────────────────────────────
FLZERO:         tst     (SP)+
                clr     R2
                clr     R3
                jmp     FPUEX           ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
;умножение A = A * B
FMUL$:          clr     -(SP)           ; флаг знака результата
                tst     R2              ; число B какое?
                bpl     1$              ; больше 0
                inc     (SP)            ; если меньше нуля, то результат будет отрицательный
1$:             tst     R4              ; число A какое?
                bpl     2$              ; больше 0
                inc     (SP)            ; если меньше нуля, то результат будет отрицательный,
                                        ; или, если B тоже было < 0, то положительный
2$:             call    MANEXP          ; разделяем мантиссу и порядок
                tst     R0              ; если порядок B.exp == 0
                beq     FLZERO          ; то результат умножения == 0
                tst     R1              ; если порядок A.exp == 0
                beq     FLZERO          ; то результат умножения == 0
                add     R0, R1          ; res.exp = A.exp + B.exp
                sub     #200, R1        ; ?
                mov     R1, -(SP)       ; порядок результата
                mov     R5, -(SP)       ; A.m.lo ->
                mov     R4, -(SP)       ; A.m.hi ->
                mov     R3, -(SP)       ; B.m.lo ->
                mov     R4, R3          ; A.m.hi
                mov     R5, R4          ; A.m.lo
                mov     R2, R5          ; B.m.hi
                call    IMUL            ; умножение R0:R1 = R3:R4 * R5
                                        ; умножаем A.m на B.m.hi
                mov     R1, -(SP)       ; результат сохраним
                mov     R0, -(SP)
                mov     4(SP), R5       ; B.m.lo
                beq     3$              ; если 0, незачем умножать
                mov     6(SP), R4       ; А.m.hi
                clr     R3
                call    IMUL            ; умножение R0:R1 = R3:R4 * R5
                                        ; умножаем A.m.hi на B.m.lo
                add     R1, 2(SP)       ; складываем с предыдущем результатом
                adc     (SP)
                add     R0, (SP)
                mov     10(SP), R4      ; A.m.lo
                beq     3$              ; если 0, незачем умножать
                mov     4(SP), R5       ; B.m.lo
                clr     R3
                call    IMUL            ; умножение R0:R1 = R3:R4 * R5
                                        ; умножаем A.m.lo на B.m.lo
                add     R0, 2(SP)       ; складываем с предыдущем результатом
                adc     (SP)
                                        ; что-то не пойму логику.
                                        ; res = A.m * B.m.hi + (A.m.hi + A.m.lo) * B.m.lo
3$:             clr     R2              ; быстрый сдвиг на 8 вправо
                bisb    1(SP), R2       ; берём старший байт ст. слова результата (чтобы не расширялся знак не исп. mov)
                mov     2(SP), R1       ; берём мл слово результата
                swab    R1              ; переставляем байты
                movb    (SP)+, (SP)     ; замещаем младший байт мл слова младшим байтом ст слова результата
                mov     (SP)+, R3       ; и достаём это
                swab    R3              ; переставляем байты
                                        ; в результате получается res = R2:R3:R1
                                        ; в старшем байте R2 - 0, в младшем байте R1 - незначащий мусор
                add     #6, SP          ; освобождаем стек
                jmp     NORMLT          ; нормализация только влево

; выделение порядков чисел и их мантисс
MANEXP:         call    SEPEXP
                bic     #177600, R2     ; выделяем мантиссу B (B.m)
                bic     #177600, R4     ; выделяем мантиссу A (A.m)
                bis     #200, R2        ; добавляем подразумеваемый бит в B.m
                bis     #200, R4        ; добавляем подразумеваемый бит в A.m
                return

; выделение порядков чисел
SEPEXP:         mov     R2, R0
                asl     R0
                clrb    R0
                swab    R0              ; выделяем порядок B (B.exp)
                mov     R4, R1
                asl     R1
                clrb    R1
                swab    R1              ; выделяем порядок A (A.exp)
                return

; ───────────────────────────────────────────────────────────────────────────
;вычитание A = A - B - это A + (-B)
FSUB$:          call    SEPEXP          ; выделение порядков чисел
                tst     R0              ; B.exp == 0 ?
                beq     1$ADD           ;да, пойдём, прибавим 0
                add     #100000, R2     ;иначе, поменяем знак B = -B
;сложение A = A + B
FADD$:          call    SEPEXP          ; выделение порядков чисел
                tst     R0              ; что мы там прибавляем?
                bne     1$              ; не ноль
1$ADD:          mov     R4, R2          ; а если 0, то просто
                mov     R5, R3          ; res = A
                br      FPUEX           ; установка признаков N и Z

1$:             tst     R1              ; а если A == 0, то res = B
                beq     FPUEX           ; установка признаков N и Z
                mov     R2,-(SP)
                bic     #177600, R2     ; оставляем в R2:R3 только мантиссу B (B.m)
                bis     #200, R2        ; добавляем подразумеваемый бит
                tst     (SP)+           ; а число B какое?
                bpl     2$              ; положительное
                neg     R3              ; отрицательное - поменяем знак мантиссы
                adc     R2
                neg     R2
2$:             mov     R4,-(SP)
                bic     #177600, R4     ; оставляем в R4:R5 только мантиссу A (A.m)
                bis     #200, R4        ; добавляем подразумеваемый бит
                tst     (SP)+           ; а число A какое?
                bpl     3$              ; положительное
                neg     R5              ; отрицательное - поменяем знак мантиссы
                adc     R4
                neg     R4
3$:             clr     -(SP)           ; флаг знака результата
                mov     R0, -(SP)       ; B.exp
                sub     R1, R0          ; B.exp = B.exp - A.exp
                bhi     4$              ; если B.exp > A.exp
                blo     5$              ; если B.exp < A.exp
                ;если B.exp == A.exp
                clr     R1              ; tmp = 0
                br      6$              ; сдвигать не надо

;B.exp < A.exp
5$:             mov     R1, (SP)        ; вместо B.exp поместим A.exp
                neg     R0              ; A.exp - B.exp
                mov     R2, R1          ; B.m <--> A.m
                mov     R4, R2          ; меняем местами мантиссы A и B
                mov     R1, R4
                mov     R3, R1
                mov     R5, R3
                mov     R1, R5
;B.exp > A.exp
4$:             clr     R1              ; tmp = 0 (вытесненные биты из выровненной мантиссы)
                cmp     R0, #24.        ; есть смысл двигать биты?
                ble     7$              ; да
                clr     R4              ; нет, сразу A.m = 0
                clr     R5
                br      6$
;B.exp - A.exp <= 24.
7$:
;выравниваем мантиссы в соответствии с порядками.
8$:             asr     R4              ; и двигаем A.m вправо
                ror     R5
                ror     R1              ; а сюда принимаем биты
                sob     R0, 8$

6$:             add     R5, R3          ; res.m = B.m + A.m
                adc     R2
                add     R4, R2
                bpl     9$              ; если >= 0, переход
                neg     R1              ; иначе меняем знак
                adc     R3
                adc     R2
                neg     R3
                adc     R2
                neg     R2
                inc     2(SP)           ; и фиксируем этот факт

9$:             mov     R3, R4          ; проверяем, что получилось
                bis     R2, R4
                bis     R1, R4
                bne     NORMRT          ; что-то получилось - переход
                cmp     (SP)+, (SP)+    ; все нули, освобождаем стек
                br      FPUEX           ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
; нормализуем мантиссу вправо
NORMRT:         cmp     R2, #400        ; res.hi умещается в мл байт?
                blo     NORMLT          ; да
                asr     R2              ; нет, двигаем вправо
                ror     R3
                ror     R1
                inc     (SP)            ; корректируем порядок
                br      NORMRT          ; и так пока не станет умещаться.
; ───────────────────────────────────────────────────────────────────────────
; нормализуем мантиссу влево
NORMLT:         tstb    R2              ; старший бит мантиссы == 1 ?
                bmi     1$              ; да
2$:             dec     (SP)            ; корректируем порядок
                asl     R1              ; двигаем влево
                rol     R3
                rolb    R2
                bpl     2$              ; и так, пока старший бит мантиссы не станет 1

1$:             asl     R1              ; округляем до двухсловного числа
                adc     R3
                adcb    R2
                bcc     3$              ; переполнения не случилось?
                inc     (SP)            ; случилось - скорректируем порядок.
3$:             clr     R5              ; буфер флагов
                mov     (SP)+, R4       ; достаём порядок из стека
                ble     UFLOW           ; если <=0, то переполнение underflow
                swab    R4              ; команда сбрасывает бит C
                bne     OFLOW           ; если не влазит в 8 бит, то переполнение overflow
                ror     R4              ; сдвигаем порядок вправо
                ror     (SP)+           ; достаём знак результата
                bcc     6$              ; если +, то переход
                bis     #100000, R2     ; если -, то формируем знаковый бит
6$:             bic     #200, R2        ; очищаем подразумеваемый бит мантиссы
                bis     R4, R2          ; помещаем порядок на место

C=1
V=2
Z=4
N=10

;установка признаков N и Z
FPUEX:          clr     R5              ; тут формируются признаки
                tst     R2              ; res.hi == 0 ?
                bne     1$              ; нет
                bis     #Z, R5          ; да - формируем Z
1$:             bpl     2$              ; res.hi >= 0 или просто переход после bis
                bis     #N, R5          ; res.hi < 0 - формируем N
; Результат: R2 - ст. часть, R3 - мл. часть
2$:             mov     (SP)+, R1       ; конец блока параметров
                mov     (SP)+, R0       ; адрес в стеке, где хранится значение используемого регистра
                mov     R3, -(R1)       ; сохраняем res на место A
                mov     R2, -(R1)
                mov     R1, (R0)        ; а адрес res - в регистр
                sub     SP, R0          ; а теперь проверим, какой это был регистр
                cmp     R0, #12.
                blo     3$              ; если это R0-R5, то всё как обычно
                beq     4$              ; если это SP
                add     #4, 16(SP)      ; если это PC - то он должен указывать за res,
                                        ; а не на него, как все остальные регистры
3$:             call    RSTRS           ; установим признаки из R5 и восстановим регистры
                call    RETEXT
                rti
; ───────────────────────────────────────────────────────────────────────────
4$:             call    RSTRS           ; установим признаки из R5 и восстановим регистры
                call    RETEXT
                mov     (SP)+, 2(SP)    ; переместим PS/PC в стеке на место B,
                mov     (SP)+, 2(SP)    ; оно всё равно не нужно
                rti                     ; и выходим. Изящно получается со стеком в качестве буфера
; ───────────────────────────────────────────────────────────────────────────
DIVZER:         mov     #C, R5          ; формируем C
UFLOW:          bis     #N, R5          ; формируем N
OFLOW:          bis     #V, R5          ; формируем V
                cmp     (SP)+, (SP)+    ; убираем из стека флаг знака и конец блока параметров fis
                mov     (SP)+, R0       ; достаём адрес в стеке, где хранится значение используемого регистра
                sub     SP, R0          ; проверим, какой это был регистр
                cmp     R0, #14.        ; это PC?
                bne     1$              ; нет
                add     #8., 16(SP)     ; да - передвинем его за блок параметров
1$:             call    RSTRS           ; установим признаки из R5 и восстановим регистры
                call    RETEXT
                mov     @#246, -(SP)    ; эмулируем возникновение прерывания по ошибке
                mov     @#244, -(SP)    ; СППЗ
                rti                     ; если кто об этом не знал, ему же хуже.
; ───────────────────────────────────────────────────────────────────────────

EISSET:         cmp     R0, #70000      ; точно eis?
                bhis    1$              ; да
                jmp     ILCOD$          ; нет - другие не эмулируемые опкоды
; ───────────────────────────────────────────────────────────────────────────
1$:             bic     #170777, R0     ; выделим код опкода
                swab    R0              ; вот он уже умноженный на 2
                mov     R1, R2
                bic     #177770, R1     ; выделим регистр источника
                asl     R1              ; *2
                asr     R2
                asr     R2
                mov     R2, R3
                bic     #177761, R2     ; выделим код адресации источника *2
                asr     R3
                asr     R3
                asr     R3
                bic     #177761, R3     ; выделим регистр приёмника *2
                mov     #2, R4
                bis     R3, R4          ; а это R+1 приёмника
                add     SP, R3          ; находим адрес в стеке, где находится содержимое регистров приёмника
                add     SP, R4
                mov     R1, -(SP)       ; регистр источника сохраним
                add     SP, R1          ; находим адрес в стеке, где находится содержимое регистра источника
                add     #2, R1
                add     R2, PC          ; и переходим обрабатывать адресацию
                br      ADDR01          ; 0 Rx
                br      ADDR01          ; 1 (Rx)
                br      ADDR23          ; 2 (Rx)+
                br      ADDR23          ; 3 @(Rx)+
                br      ADDR45          ; 4 -(Rx)
                br      ADDR45          ; 5 @-(Rx)
                br      ADDR67          ; 6 n(Rx)
                br      ADDR67          ; 7 @n(Rx)
; ─ автоинкрементная адресация ──────────────────────────────────────────────
ADDR23:         inc     (SP)            ; номер регистра источника ++ - признак автоинкрементной адресации
                mov     (R1), R5        ; берём содержимое регистра источника
                add     #2, (R1)        ; инкрементируем
                br      MODEX
; ─ автодекрементная адресация ──────────────────────────────────────────────
ADDR45:         sub     #2, (R1)        ; декрементируем
                mov     (R1), R5        ; берём содержимое регистра источника
                br      MODEX
; ─ индексная адресация ─────────────────────────────────────────────────────
ADDR67:         mov     @20(SP), R5     ; берём индекс по содержимому PC
                add     #2, 20(SP)      ; прибавляем к содержимому PC два
                add     (R1), R5        ; прибавляем к индексу содержимое регистра источника
                br      MODEX
; ─ регистровая адресация ───────────────────────────────────────────────────
ADDR01:         mov     R1, R5          ; берём регистр источник
MODEX:          bit     #2, R2          ; адресация относительная?
                beq     1$              ; нет
                mov     (R5), R5        ; да - значит получим значение по адресу значения
1$:             mov     R4, -(SP)       ; R+1 приёмника
                mov     R3, -(SP)       ; R приёмника
                add     PC, R0
                add     #EISTBL-., R0
                add     (R0), PC
EISTBL:         .word   MUL$-EISTBL     ; 70000
                .word   DIV$-EISTBL     ; 71000
                .word   ASH$-EISTBL     ; 72000
                .word   ASHC$-EISTBL    ; 73000
                .word   XOR$-EISTBL     ; 74000
; ───────────────────────────────────────────────────────────────────────────
; умножение R:R+1 = R * ss
MUL$:           mov     (R3), R4        ; берём мл. часть
                beq     2$              ; если 0, то результат 0
                mov     (R5), R5        ; берём источник
                beq     2$              ; если 0, то результат 0
                bpl     1$              ; если >= 0, то идём умножать
                neg     R4              ; иначе R4 = -R4
                neg     R5              ; R5 = -R5
                bpl     1$              ; если >= 0, то идём умножать
                                        ; иначе в R5 число 100000
                mov     R4, R3          ; R4 <-> R5
                mov     R5, R4
                mov     R3, R5
                bpl     1$              ; если >= 0, то идём умножать
                neg     R5              ; иначе R5 = -R5
                bmi     4$              ; если < 0, то и в R4 тоже было число 100000
1$:             tst     R4              ; умножаем
                sxt     R3
                call    IMUL            ; умножение R0:R1 = R3:R4 * R5
                                        ; на выходе в R5 нуль
                tst     R1              ; посмотрим
                sxt     R2              ; какой знак у мл. части
                cmp     R0, R2          ; если знак распространён на ст. часть
                beq     3$              ; то всё нормально
                bis     #C, R5          ; иначе бит C - результат больше 15 бит длиной
3$:             jmp     DWTST

4$:             mov     #40000, R0      ; результат умножения 100000 * 100000
                br      31$
2$:             clr     R0              ; результат
31$:            clr     R1
                clr     R5              ; флаги
                jmp     DWTST           ; выходим

; ───────────────────────────────────────────────────────────────────────────
; деление R = R:R+1 / ss , R+1 = R:R+1 % ss
DIV$:           clr     -(SP)           ; флаг знака результата
                mov     (R3), R0        ; значение R приёмника
                mov     (R4), R1        ; значение R+1 приёмника
                mov     R0, -(SP)       ; знак делимого
                bpl     1$
                inc     2(SP)
                neg     R1
                adc     R0
                neg     R0
                bmi     2$              ; делимое = 100000
1$:             mov     (R5), R4        ; делитель
                beq     3$              ; не дели на "0"
                bpl     4$
                inc     2(SP)
                neg     R4
                bmi     2$              ; это 100000
4$:             clr     R5
                cmp     R0, R4
                bgt     2$              ; делимое/делитель > 2**16
                blt     5$
                cmp     R1, R4
                bhis    2$
5$:             clr     R2
                mov     #16., R3        ; счётчик сдвигов

6$:             asr     R4
                ror     R5
                sub     R5, R1
                sbc     R0
                sub     R4, R0
                bmi     7$
8$:             sec
                rol     R2
                sob     R3, 6$
                br      9$

10$:            asr     R4
                ror     R5
                add     R5, R1
                adc     R0
                add     R4, R0
                bpl     8$
7$:             clc
                rol     R2
                sob     R3, 10$
                add     R5, R1          ; восстановить остаток

9$:             tst     (SP)+
                bpl     11$
                neg     R1              ; знак остатка - как у делимого
11$:            asr     (SP)+
                bcc     12$             ; знак частного?
                neg     R2
12$:            clr     R5              ; установить коды условий
                mov     R2, R0
                bpl     13$
                bis     #N, R5          ;N
13$:            bne     14$
                bis     #Z, R5          ;Z
14$:            jmp     EISEX
;деление на 0 - ошибка
3$:             mov     #V+C, R5        ; флаги VC
                br      15$

2$:             mov     #V, R5          ; переполнение V
15$:            add     #8., SP         ; результат не сохраняется
                jmp     EISABO

;получаем R и число битов для сдвигаем
;выход: R2 = 0
;       R0 = R
;       R5 = счётчик сдвигов
;       Z - в счётчике 0
;       С - сдвиг вправо
OPSHIFT:        clr     R2
                mov     (R3), R0        ; значение R приёмника
                mov     (R5), R5        ; значение источника
                bit     #40, R5         ; смотрим знак
                beq     1$              ; +
                bis     #177700, R5     ; - , устанавливаем биты
                neg     R5              ; и меняем знак
                return

1$:             bic     #177700, R5     ; очищаем биты
                return

; ───────────────────────────────────────────────────────────────────────────
;арифметический сдвиг R = R << ss / R = R >> ss
ASH$:           mov     R3, 2(SP)       ; R+1 заменяем на R
                call    OPSHIFT         ; подготовка
                beq     1$              ; 0, не надо ничего двигать
                bcs     2$              ; двигать вправо
3$:             asl     R0              ; двигаем влево
;                bvc     4$
;                inc     R2              ; а тут отмечаем возникновение бита V
;4$:             sob     R5, 3$          ; на заданное количество бит
;                br      1$
                sob     R5, 3$          ; на заданное количество бит
                bvc     1$              ; если при последней операции сдвига получилось переполнение
                inc     R2              ; тут отмечаем возникновение бита V
                br      1$
; в другом источнике другая логика появления бита V, там сравнивается начальный и конечный результат

2$:             asr     R0              ; двигаем вправо, тут переполнения не бывает
                sob     R5, 2$          ; на заданное количество бит
1$:             mov     R0, R1          ; результат дублируем и для R+1
                br      SHDONE
; ───────────────────────────────────────────────────────────────────────────
;арифметический сдвиг R:R+1 = R:R+1 << ss / R:R+1 = R:R+1 >> ss
ASHC$:          mov     (R4), R1        ; значение R+1 приёмника
                call    OPSHIFT         ; подготовка
                beq     SHDONE          ; 0, не надо ничего двигать
                bcs     1$              ; двигать вправо
2$:             asl     R1              ; двигаем влево
                rol     R0
;                bvc     3$
;                inc     R2              ; а тут отмечаем возникновение бита V
;3$:             sob     R5, 2$          ; на заданное количество бит
;                br      SHDONE
                sob     R5, 2$          ; на заданное количество бит
                bvc     SHDONE          ; если при последней операции сдвига получилось переполнение
                inc     R2              ; тут отмечаем возникновение бита V
                br      SHDONE

1$:             asr     R0              ; двигаем вправо, тут переполнения не бывает
                ror     R1
                sob     R5, 1$          ; на заданное количество бит
                br      SHDONE
; ───────────────────────────────────────────────────────────────────────────
; операция исключающее или.
; dd = dd xor R
XOR$:           mov     (R3), R4
                bic     (R5), R4
                bic     (R3), (R5)
                bis     R4, (R5)
                bne     1$
                bis     #Z, R5
                br      2$

1$:             bpl     2$
                bis     #N, R5
2$:             bic     #177760, R5
                cmp     (SP)+, (SP)+
                br      EISABO
; ───────────────────────────────────────────────────────────────────────────
; вход только для ASH/ASHC
; вход R0:R1 - результат
;       R5 - нуль
;       R2 - признак возникновения переполнения V
SHDONE:         adc     R5              ; ставим флаг C, если было
                tst     R2
                beq     DWTST
                bis     #V, R5          ; ставим флаг V
; вход R0:R1 - результат
;       R5 - флаги
DWTST:          tst     R0              ; смотрим знак результата
                bpl     1$              ; >= 0
                bis     #N, R5          ; < 0 - ставим флаг N
1$:             bne     EISEX           ; идём туда
                tst     R1
                bne     EISEX
                bis     #Z, R5          ; если R0:R1 == 0, ставим флаг Z
EISEX:          mov     R0, @(SP)+      ; ст часть в R
                mov     R1, @(SP)+      ; мл часть в R+1
EISABO:         cmp     (SP)+, #13.     ; если регистр источник был SP и адресация была автоинкрементная
                beq     2$              ; то переход
                call    RSTRS           ; установим признаки из R5 и восстановим регистры
                call    RETEXT
                rti                     ; и выходим
; ───────────────────────────────────────────────────────────────────────────
2$:             call    RSTRS           ; установим признаки из R5 и восстановим регистры
                call    RETEXT
                ; для автоинкрементной адресации со стеком, аргумент источника был в стеке, поэтому
                mov     2(SP), 4(SP)    ; сдвинем PS/PC на место аргумента
                mov     (SP)+, (SP)     ; сделаем освобождение стека от аргумента
                rti                     ; и выходим

                .end


